package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1SequenceParser;
import cn.com.infosec.asn1.ASN1TaggedObjectParser;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;

public class EncryptedContentInfoParser {
   private DERObjectIdentifier _contentType;
   private AlgorithmIdentifier _contentEncryptionAlgorithm;
   private ASN1TaggedObjectParser _encryptedContent;

   public EncryptedContentInfoParser(ASN1SequenceParser seq) {
      this._contentType = (DERObjectIdentifier)seq.readObject();
      this._contentEncryptionAlgorithm = AlgorithmIdentifier.getInstance(seq.readObject().getDERObject());
      this._encryptedContent = (ASN1TaggedObjectParser)seq.readObject();
   }

   public DERObjectIdentifier getContentType() {
      return this._contentType;
   }

   public AlgorithmIdentifier getContentEncryptionAlgorithm() {
      return this._contentEncryptionAlgorithm;
   }

   public DEREncodable getEncryptedContent(int tag) {
      return this._encryptedContent.getObjectParser(tag, false);
   }
}
